import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;



public class DocumentTests {

    public static void explain(Manager M,String S) {
	try {M.D.setExplain(S);}
	catch(Exception e) {}
	M.repaint();
    }



    public static void testInfo(Manager M) {
        String S="test window";

	S=S+"\n\nThis window controls the computational tests used extensively in the monograph.  These tests are described in detail in Chapter 11 of the monograph.  In all cases, the tests are performed on the auxiliary polygon DOMAIN. Sometimes the tests also involve the auxiliary polygon CONTAINER.  When you select a piece of the partition, DOMAIN is set to equal this piece, though for the purposes of debugging or experimentation you can change DOMAIN and CONFINER.  There is always a primary map associated to the selected piece, and the test involves this primary map.  If you change the primary map, the test will work on the new primary map.  For some of the tests in Chapter 12 of the monograph, you want to test ALL the primary maps on a given piece.  For these tests, you have to manually change the primary map.";

	S=S+"\n\nIf the above explanation does not make sense, you should press the info button next to the `polygons' option on the main display panel.  This will give you more information about DOMAIN and CONTAINER.  If you select the info button on the green map selector, then you can learn more about the primary maps.";

	S=S+"\n\nThe thing we want to emphasize is that a button click on a piece usually sets up the given test just as it is in the monograph.  However, you can change all the main inputs to the test, DOMAIN, CONTAINER, and the primary map.  In this way, you can experiment and see that the tests are really doing something.  For instance, suppose you want to check that the confiner test is working properly.  You can select a given piece such as P1 and then modify CONTAINER so that the given primary map does not map DOMAIN into CONFINER.  Then when you run the test you will see it struggle and fail.  This is some evidence that the test works properly.";

	S=S+"\n\nOnce you select DOMAIN and CONFINER, you select one of the tests and then press GO.  When the test runs, an auxiliary monitor pops up in this window and shows the progress of the test.  If the monitor turns bright blue then the test is a success.  If the monitor turns red, the test is a failure.";

	S=S+"\n\nThe tests are all performed over the ring R[\u03D5,\u03A8], where";
	S=S+"\n\nR is the ring of dyadic rationals.";
	S=S+"\n\u03D5=(1+\u221A5)/2.";
	S=S+"\n\u03A8=(1+\u221A13)/2.";
	S=S+"\n\n  Each test produces a partition of the given polygon into triangles on which the polygon is what we call positive dominant or weak positive dominant.  The more little triangles produced, the tougher the test. You can clear these plotted triangles using the RESET button on the main window."; 

	S=S+"\n\nSome of the tests (area, L2norm, cone, stretch) bring up auxiliary control panels which let you specify the details of the test.  For instance, if you select the area test, then the auxiliary panel lets you specify the lower bound on the area of the determinant of the primary map you are testing.  As an exercise, select the piece R and test whether the determinant of the associated primary map is at least 5.";

        explain(M,S);
    }

    public static void debugInfo(Manager M) {
	String S=debug();
        explain(M,S);
    }

    public static void denomInfo(Manager M) {
	String S=denom(); 
	explain(M,S);
    }

    public static void confinerInfo(Manager M) {
	String S=confiner(); 
	explain(M,S);
    }

    public static void excluderInfo(Manager M) {
	String S=excluder();  
	explain(M,S);
    }

    public static void areaInfo(Manager M) {
	String S=area();
	explain(M,S);
    }

    public static void expandInfo(Manager M) {
	String S=expand();
	explain(M,S);
    }

    public static void testValueInfo(Manager M) {
	String S="test value setter\n\nWhen we run the area, expand, and diff tests, we specify certain upper or lower bounds which depend on the partition piece being tested.  This control panel lets you modify the values so that you can see how the tests perform with other values.  For instance, if you increase the lower bounds on the area test significantly, the tests will fail.  You could think of this feature as a control for the original tests.";

	S=S+"\n\nWhen you select one of the relevant tests, a row of squares appears, and you click on these squares to select the piece to be tested.  The values of this control panel are set to their original values when you click on the row of squares.";
	explain(M,S);
    }

    public static void pieceInfo(Manager M) {
	String S="piece selector\n\nWhen we run the area, expand, and diff tests, you need to first select a piece to be tested.  This row of squares lets you select the piece.  The piece values are as follows:";
	S=S+"\narea test: 0,1,2,3,4,5";
	S=S+"\nexpand test: 0,1,2,3,4,5";
	S=S+"\ndiff test: 6,7,8,9,10,11,12,13";
	S=S+"\nYou cannot run the tests on pieces other than these.";

	S=S+"\n\nWhen you click on one of the squares, the bounds for the test are also set. These bounds are displayed in the dark blue window at right.";
	explain(M,S);
    }



    public static String debug() {
	String S= "debugger\n\nThis prints out the results of various computations done by the computer, such as polynomial multiplication, to see that it is done correctly.  In general, we do the relevant calculation several unrelated ways, on random inputs, and see that they match.";
	return(S);
    }



    public static String denom() {
	String S= "denominator test\n\nYou select:\n\n--a piece P of the partition\n--a primary element F.\n\n Then, this tests whether the denominators F do not vanish on the piece.";
	return(S);
    }


    public static String confiner() {
	String S= "confinement test\n\nYou select:\n\n--a piece P of the partition\n--a primary map F\n--the polygon DOMAIN.\n--The polygon CONTAINER\n\n Then, this tests whether F maps DOMAIN into CONTAINER.   The test presupposes that the denominators of F do not vanish on DOMAIN.  So, you should use the denom test first.";
	return(S);
    }


    public static String excluder() {
	String S= "exclusion test\n\nYou select:\n\n--a piece P of the partition\n--a primary map F\n--the polygon DOMAIN.\n--The polygon CONTAINER\n\n Then, this tests whether F maps DOMAIN disjointle from CONTAINER.   The test presupposes that the denominators of F do not vanish on DOMAIN.  So, you should use the denom test first.";
	return(S);
    }



    public static String area() {
	String S="area lower bound";
	S=S+ "\n\nYou select:\n\n--a primary map F\n--the polygon DOMAIN.\n--A value D on the auxiliary control panel that pops up.";
	S=S+"\n\nThis then tests whether |det(dF)| > D on DOMAIN.";
	return(S);
    }



    public static String expand() {
	String S="L2 norm upper bound";
	S=S+ "\n\nYou select:\n\n--a primary map F\n--the polygon DOMAIN.\n--Values B1 and B2 on the auxiliary control panel that pops up.";
	S=S+"\n\nThis then tests whether the square of the L2 norm of dF is less than B1+B2.  The sum-of-squares expression involves 4 terms, which we split up into two groups and test separately. We do this for the technical reason that the rational functions involved are much simpler this way.";
	return(S);
    }

    public static void coneInfo(Manager M) {
	String S="cone test";
	S=S+ "\n\nYou select:\n\n--a primary map F\n--the polygon DOMAIN.\n--a pair of cones C1 and C2.";

	S=S+"\n\nThis tests whether dF maps the cone V into the cone W throughout DOMAIN. It performs the cone test from the monograph.\n\n You specify a basis V1,V2 for V and a basis W1,W2 for W.  You can then test whether dF(Vi) has a positive dot product with Wj for each pair of indices i,j.";

	S=S+"\n\n The test is such that you might need to take -W1 and -W2 instead of W1 and W2.  You can use the `negate cone' button to make this switch.  Also, in case W is an acute cone, you need to take the new cone W' which is bounded by the lines orthogonal to the lines bounding W.   This is explained in the monograph. The `ortho cone' button automatically makes this change for you.";
	Documentation.explain(M,S);
    }


    public static void stretchInfo(Manager M) {
	String S="L2 stretch test";
	S=S+ "\n\nYou select:\n\n--a primary map F\n--the polygon DOMAIN.\n--a cone C1.";
	S=S+"\n\nA lower bound B.";

	S=S+"\n\nThis is a very specialized test, which we only use once in the monograph. It tests whether some linear inequality holds for a pair V1,V2 of vectors in the boundary of the cone.  Setting (X1,Y1)=dF(V1) and (X2,Y2)=dF(V2) the main application is that X1,X2>8.  If we choose V1=(1,1) and V2=(-1,1) then this calculation shows that dF stretches all timelike vectors in the standard light cone by at least a factor of 5.";
	Documentation.explain(M,S);
    }

    public static void strictInfo(Manager M) {
	String S="test strength";
	S=S+"\n\nThis control panel works in tandem with the tests.  It specifies whether we use the weak or strong version of the positive dominance algorithm.  There is a third option, which only works with the denom test.  This option implements the subtraction trick discussed in connection with the denominator test in the monograph. If you try to run the strong test on a partition piece which contains a blowup point in its boundary, the test will fail.";
	explain(M,S);
    }

}
