import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;



public class DocumentTutorial {


    public static void rescale(Manager M) {
	String S="rescaling the picture:";
	S=S+"\n\nThe program works with a 3-button mouse.  A left button click zooms into the picture.\n A right button click of the zooms out. \nThe middle button is used for selecting points.\n\n  You can also use the keyboard:\n\n z: zoom in\n x:select point\n c: zoom out.";
	S=S+"\n\nHere is how to change the strength of the zooming:";
	S=S+"\n\n1. Open up the PLOT DETALS window.";
	S=S+"\n\n2. Click a button on the `zoom strength' lever.";
	S=S+"\n\n3. (If you like) close the PLOT DETAILS window.";

	S=S+"\n\nThere are some preset scales which give nice views of the picture.  Here is how to use these.";
	S=S+"\n\n1. Open up the PLOT DETALS window.";
	S=S+"\n\n2. Click a button on the `preset scales' lever.";
	S=S+"\n\n3. (If you like) close the PLOT DETAILS window.";
	S=S+"\n\nThe RESET button also resets the scale.";

	Documentation.explain(M,S);
    }

    public static void pointer(Manager M) {
	String S="using the pointer";
	S=S+"\n\n1. Go to the map selector and select the map you like.";
	S=S+"\n\n2. Turn on the `pointer' display by clicking the middle square next to the word 'pointer' on the main display panel.";
	S=S+"\n\n3.Click the middle mouse button (or key x) over the picture window.";
	S=S+"\n\n4.Drag using the middle mouse button to see a continuously varying effect.  You can also do this by holding down the x-hey and moving the mouse.";

	S=S+"\n\nLet's use the pointer to explore the edges of the fundamental domain.";
	S=S+"\n\n5. Select the map 120.";
	S=S+"\n\n6. Click the middle mouse AWAY from any of the partition pieces. (A different map gets selected if you click on one of the partition pieces, but the map does not change while you drag.)";
	S=S+"\n\n7. Drag the mouse near the bottom edge of the blue triangle and observe how this edge is fixed pointwise by the map 120.";
	S=S+"\n\n8. Repeat Steps 5-7 using the map 100 and the diagonal edge.";
	S=S+"\n\n9. Repeat Steps 5-7 using the map 130 and the vertical edge. This time you will see that the map 130 stabilizes the vertical edge but does not fix it pointwise.  As an exercise, try to locate (nearly) the point on the vertical edge that is fixed by 130.";

	Documentation.explain(M,S);
    }

    public static void recolor(Manager M) {
	String S="recoloring";
	S=S+"\n\n1. Turn on the pointer display by clicking the middle square next to the word 'pointer' on the main display.";
	S=S+"\n\n2. Open up the PLOT DETAILS window by clicking on the 'plot details' button on the control panel.";
	S=S+"\n\n3. Select your favorite color on the color selector that appears in the PLOT DETAILS window.";
	S=S+"\n\n4. Click on the left button next to the word 'pointer'.  This should change the color of the pointer to your favorite color.";
	S=S+"\n\n5. Try to make your color semi-transparent by clicking on the bottom lever of the color selector and moving it to the left.";
	S=S+"\n\nRepeat Steps 1-4 using the 'core' display on the main display panel using a semi-transparent color.";
	S=S+"\n\nOther objects are recolored in a similar way.";

	Documentation.explain(M,S);
    }

    public static void modify(Manager M) {
	String S="modifying DOMAIN and CONTAINER";

	S=S+"\n\nYou should first read the tutorial about DOMAIN and CONTAINER.  This part of the tutorial gives an in-depth discussion of how to modity DOMAIN and CONTAINER.";

	S=S+"\n\n1. Turn on the 'polygons' display.";
	S=S+"\n\n2. Select a partition piece with 4 vertices. I recommend J4.";
	S=S+"\n\n3. Open the POLY SELECT window.  If necessary set the top lever to DOMAIN.";

	S=S+"\n\n4. Find the lever that changes the number of points of DOMAIN and change it from 4 to 3.  Notice how a vertex of DOMAIN disappears.";

	S=S+"5. \n\n Change the number of points to 5.  Use key-5 to reposition the 5th vertex. (Initially it is set to be the origin.";

	S=S+"\n\n6. Change the coordinate lock lever so that the x coordinate is locked.  Continue changing vertex 5 and notice how just the y-coordinate responds to your new choices.";

	S=S+"\n\n7. Repeat Step 6 so that the y coordinate is locked.  Then unlock both coordintes.";

	S=S+"\n\n8. Click the left most button on the approximation lever and continue moving vertex 5 around.  Notice how vertex 5 now snaps to an already existing partition vertex.";

	S=S+"\n\n9. Change the number of vertices of DOMAIN to 3.  Click key-1 over one of the vertices of DOMAIN and then click both key-2 and key-3 over an adjacent vertex. You have just selected a degenerate triangle which coincides with an edge of the partition piece.  This how we set things up when we want to perform computational tests on the edges of the pieces.";

	S=S+"\n\n10. Change the 'selection mode' lever to 'manual'. You should see some green rectangles appear.";

	S=S+"\n\n11. Click on these green rectangles and set the numbers to 5 8 5 8. Then press key-1 on the picture canvas.  This moves vertex 1 of DOMAIN to the point with coordinates (5+8 \u03D5,5+8\u03D5).";

	S=S+"\n\n12. Change the top lever from 'domain' to 'container' and repeat some of the above steps.";

	Documentation.explain(M,S);
    }



    public static void partition(Manager M) {
	String S="DOMAIN and CONTAINER";
	S=S+"\n\n1. Click the middle button next to the word 'polygon' on the main display.  This will bring forth an auxiliary polygon display panel";
	S=S+"\n\n2. Press the middle mouse button over a point on the blue square.  This selects a partition piece.  Try to select one of the pieces named I,J,or P. These will give a nice clean picture.";

	S=S+"\n\n3. On the auxiliary polygon display panel, go down the list of 6 items and click several times each over the middle squares besides the words.  This will show you what we mean by DOMAIN, and what we mean by CONTAINER, and how to selectively turn on and off these displays of these objects.";

	S=S+"\n\n4. Turn on the pointer and see how you can point from DOMAIN into the image of DOMAIN.";

	S=S+"\n\n5. Move the mouse button near the point of DOMAIN labeled 1.  Press key-1 on the keyboard. (I mean the number 1) Notice how you have altered DOMAIN.";

	S=S+"\n\n6. Repeat step 5 for the vertices labeled 2,3,4...";

	S=S+"\n\n7. Click again in the partition piece to undo your changes to DOMAIN.";

	S=S+"\n\n8. Open the POLY SELECT window.  (You do this by clicking on the rectangle labeled 'poly select' on the main control panel.) Click on the topmost lever, which says 'change which piece'.  Switch this lever from DOMAIN to CONTAINER.";

	S=S+"\n\n 9. Repeat steps 5-7. This shows how you can modify CONTAINER rather than DOMAIN.  The next lesson in the tutorial has more details about the POLY SELECT window.";

	S=S+"\n\n10. Change the top lever on the POLY SELECT window back to DOMAIN and close the POLY SELECT window.";

	S=S+"\n\n11. Open up the PLOT DETAILS window and select a new color on the color selector.";

	S=S+"\n\n12. On the auxiliary display panel click on the left botton next to the word DOMAIN.  Notice how you have changed the color of DOMAIN.  Now do the same thing for each of the remaining left buttons on the auxiliary polygon display panel.  You might want to vary the colors as you do the clicking, so as to get a nice picture.  Use semi-transparent colors for a nice effect.";  

	S=S+"\n\n13. If you have messed up the colors, press the RESET button to restore them to the original settings.  After pressing RESET, you need to turn back on the polygon display.  That is, repeat Steps 1-3.";

	S=S+"\n\n14. Close the PLOT DETAILS window and open up the POLY COORDS window. Select some more pieces and observe how their coordinates are displayed.";

	S=S+"\n\n15. Modify DOMAIN using the numbered keys and watch the coordinates change on the POLY COORDS window.  You can see either an exact display of the coordinates or else a decimal display."; 

	S=S+"\n\n16. Repeat Step 9, switch from DOMAIN to CONTAINER on the POLY COORDS window, and see how the coordinates of CONTAINER change when you modify CONTAINER using the numbered keys.";

	S=S+"\n\n17. Close the POLY COORDS window and open the PARTITION window.  Click on the various buttons on the big cluster of rectangles.  See how you are remotely selecting partition pieces.";

	S=S+"\n\n18. Type the word J4 on the PARTITION window and press the yellow key.  See how you have selected the piece J4.  This feature is a bit tricky. You first need to click on the PARTITION window before starying to enter the word.";

	Documentation.explain(M,S);
    }


    public static void denom(Manager M) {
	String S="denominator test";

	S=S+"\n\nThis tests whether the denominator of the given primary map F is nonzero on DOMAIN.  In this case, the primary map is defined and finite on DOMAIN.";

	S=S+"\n\n1. Open the TESTS window.";
	S=S+"\n\n2. Select the 'denom' option.";
	S=S+"\n\n3. Select the PDA option.";
	S=S+"\n\n4. Select the piece R and press go.";
S=S+"\n\n5.After a second the test will pass. This shows that the primary map 111 is defined on all of the closed polygon R.";

S=S+"\n\n6. Turn on the `polygon' feature on the main display panel. Using key-1, move the location of vertex 1 of DOMAIN far away from its present location.  For instance, you could move it near the origin (0,0).  Re run the test and watch it fail.";

S=S+"\n\n7. Select the piece S1 and run the test.  Watch it fail, but just barely.";

S=S+"\n\n8. Switch the test strength to WPDA and run the test.  Now it passes.  The problem is that the primary map 031 blows up at one of the vertices of DOMAIN.";

S=S+"\n\n9. Try the 'special WPDA' option. This implements the subtraction trick from the monograph.  The test will also pass.";

S=S+"\n\n10. Switch the primary map to 001 and rerun the test.  This time the test does not pass because the denominator really does vanish on DOMAIN.  The red triangles plotted on DOMAIN indicate places where the denominator is one sign and the blue triangles indicate the other sign. See the crack forming?  When you get bored watching, press stop.";

S=S+"\n\n11. Repeat steps 7-9 for the partition piece A.  This time the WPDA passes and the other two test modes fail.  Piece A is the one piece for which the WPDA and the special WPDA have different outcomes.";

	Documentation.explain(M,S);
    }

    public static void confinement(Manager M) {
	String S="confinement test";

	S=S+"\n\nThis tests whether F(DOMAIN) is contained in CONTAINER.  Here F is the associated primary map.";

	S=S+"\n\n1. Open the TESTS window.";
	S=S+"\n\n2. Select the 'confine' option.";
	S=S+"\n\n3. Select the WPDA option.";
	S=S+"\n\n4. Select the piece J4 and press go.";
S=S+"\n\n5. After a second the test will pass.";
S=S+"\n\n6. Using key-1 (the number 1) change the location of vertex 1 of DOMAIN slightly, so that F(DOMAIN) no longer appears to be contained in CONTAINER.  Now rerun the test and watch it fail.";
S=S+"\n\n7. Open the SELECT POLY window and change the top lever from DOMAIN to CONFINER. Uing the number keys, modify CONFINER so that it contains f(DOMAIN). Now rerun the test and watch it(probably) pass.";
	Documentation.explain(M,S);
    }

    public static void exclusion(Manager M) {
	String S="exclusion test";

	S=S+"\n\nThis tests whether F(DOMAIN) is disjoint from CONTAINER.  Here F is the associated primary map.";

	S=S+"\n\n1. Open the TESTS window.";
	S=S+"\n\n2. Select the 'exclude' option.";
	S=S+"\n\n3. Select the WPDA option.";
	S=S+"\n\n4. Select the piece S1 and press go.";
	S=S+"\n\n5. After a second the test will pass.";
S=S+"\n\n6. Using key-1 (the number 1) change the location of vertex 1 of DOMAIN slightly, so that F(DOMAIN) no longer appears to be disjoint from CONTAINER.  Now rerun the test and watch it fail.";
S=S+"\n\n7. Open the SELECT POLY window and change the top lever from DOMAIN to CONFINER. Uing the number keys, modify CONFINER so that it is disjoint from F(DOMAIN). Now rerun the test and watch it (probably) pass.";
	Documentation.explain(M,S);
    }



    public static void area(Manager M) {
	String S="area test";

	S=S+"\n\nLet F be the primary map associated to DOMAIN. This tests whether F expands area by at least a factor of D on DOMAIN.  In other words, we are checking det(dF) \u2265 D on DOMAIN.";

	S=S+"\n\n1. Open the TESTS window.";
	S=S+"\n\n2. Select the 'area' option.";
	S=S+"\n\n3. Select the WPDA option.";
	S=S+"\n\n4. Select the piece P21";
	S=S+"\n\n5. Set the area bound on the magenta window to -1+1 \u03D5.";
	S=S+"\n\n6. Press go. After a minute or so the test will pass.";
	S=S+"\n\n7. Reset the area bound to 2 and rerun the test. This time it fails immediately.";
	S=S+"\n\n8. Reset the area bound to 1 and rerun.  This time the test will take a long time to pass.  Press stop when you get tired of watching.";

	S=S+"\n\n9. Open up the debugger, select the 'diff' optn and press go.  Look at the printout on the command line.  You can see that the determinant varies roughly between 1.54 and 3.77. This gives you realistic things to aim for when you use the area test.";
	S=S+"\n\n10. Close the debugger. Select the piece K2.  Set the area bound to 0.";

	S=S+"\n\n11. Rerun the test and wait a while. You will eventually see red and blue triangles plotted. Zoom way into the picture to get a good look.  This shows where the primary map is singular in K2.  We discuss this in Chapter 14 of the monograph when we talk about the postcritical set.";

	Documentation.explain(M,S);
    }


    public static void L2norm(Manager M) {
	String S="L2 norm test";

	S=S+"\n\nLet F be the primary map associated to DOMAIN. This tests whether the L2 square norm of dF is less than B1+B2 where B1 and B2 are the selected bounds.";

	S=S+"\n\n1. Open the TESTS window.";
	S=S+"\n\n2. Select the 'L2 norm' option.";
	S=S+"\n\n3. Select the WPDA option.";
	S=S+"\n\n4. Select the piece T3.";
	S=S+"\n\n4. Set the Set the area bound on the magenta window to 45 and 45.";
	S=S+"\n\n5. Press go. After a minute or so the test will pass. This gives an upper bound of about 9.48 on the L2 norm of dF on T3, where F is the map 141.";
	S=S+"\n\n6. Now run the area test on T3 with a bound of 10.  The test will pass, showing that dF expands area by at least a factor of 10.   Since the L2 upper bound is less than the area lower bound, we see that F is an expanding diffeomorphism on the subset of T3 where it is defined. (F blows up at a vertex of T3.)";

	S=S+"\n\n7. Open up the debugger, select the 'diff' optn and press go.  Look at the printout on the command line.  You can see that the values (10,45,45) for the above tests are reasonable ones given the numerical samples of these quantities.";

	S=S+"\n\n8. Reset the bounds to 35,35 and rerun the L2 norm test on T3. You will see that it does not pass.  Press stop when you get bored of watching.";

	S=S+"\n\n9. Open up the POLY SELECT window and select 'the piece T' on the presets panel at the bottom.  Now rerun the L2 norm and area tests using the bounds (45,45,10). See that it still passes.  This is one of the tests in Chapter 12 of the monograph.";


	Documentation.explain(M,S);
    }



    public static void cone(Manager M) {
	String S="cone test";

	S=S+"\n\nThis tests whether the differential of the given primary map carries the V cone into the W cone throughout DOMAIN.";

	S=S+"\n\n1. Open the TESTS window";
	S=S+"\n\n2. Select the 'cone test' option.";
	S=S+"\n\n3. Select either the 'PDA' or the 'WPDA' option.";
	S=S+"\n\n4. Select the piece P11";
	S=S+"\n\n5. Press go and wait for the test to finish.  This proves that the differential of the associated primary map carries the V-cone into the W-cone.";
	S=S+"\n\n6.  Press the 'reset' key when the test is done. This clears the plotted triangles off the main picture window.";
	S=S+"\n\n7. Select the piece P12 and press go again. This time the test fails.";
	S=S+"\n\n8. Press the 'negate cone' button and rerun the test. Now it passes.";
	S=S+"\n\n9. Repeat all these steps for all 8 P pieces.";
	S=S+"\n\n10. Select the piece J31.  Set the V cone basis to (0,1) and (1,0).  Negate the cone again so that the W cone basis is (1,1) and (-1,1).";
	S=S+"\n\n11. Select the WPDA and press go.  The test will pass after a few minutes. ";
	S=S+"\n\n12. For comparison select the PDA and rerun the test. This time it will not pass because one of the vertices of J31 is a blowup point.  When you get tired of watching press stop.";
	S=S+"\n\n13. Try keeping the piece the same and changing the primary element manually using the green map selector.  When you rerun the test it will probably fail.  If you want to see the image of the piece J31 under the given primary map turn on the 'polygon' display.";


	Documentation.explain(M,S);
    }


    public static void stretch(Manager M) {
	String S="stretch test";

	S=S+"\n\nThis tests whether the differential of the given primary map F satisfies some linear inequality on the cone throughout DOMAIN.  We are mainly interested in the inequality Y>8 or -y>8, where (X,Y)=dF(1,1) or (X,Y)=(dF(-1,1)";

	S=S+"\n\n1. Open the TESTS window";
	S=S+"\n\n2. Select the 'stretch test' option.";
	S=S+"\n\n3. Select either the 'PDA' or the 'WPDA' option.";
	S=S+"\n\n4. Select the piece P11";
	S=S+"\n\n5. Press go and wait for the test to finish.";
	S=S+"\n\n6.  Press the 'reset' key when the test is done. This clears the plotted triangles off the main picture window.";
	S=S+"\n\n7. Select the piece P12 and press go again. This time the test fails.";
	S=S+"\n\n8. Change the B coefficient from +1 to -1 and re-run the test. Now it passes.";
	S=S+"\n\n9. Repeat all these steps for all 8 P pieces.";
	S=S+"\n\n10. You can fool around with changing the vectors and the linear functional on the auxiliary control panel.  This will show how the test can fail if the various parameters are changed. However, these altered tests have no connection to the proof in the monograph.";

	Documentation.explain(M,S);
    }


}
