import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class SelectCanvas extends ScaleCanvas implements MouseListener, MouseMotionListener, KeyListener {
    Manager M;
    PolyVector[] V=new PolyVector[100];
    Color[] COLOR=new Color[100];
    int count;
    int VTX;
    int history;
    Point JX;
    boolean DRAG;
    ComputeTests CT;


     public SelectCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 addKeyListener(this);
	 setScales(180,150,80);	
	 setPolygons(7,1);
	 history=-1;
	 count=1;
	 DRAG=false;
	 CT=new ComputeTests(0);
     }

   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);

        drawBg(g);
        drawPolygons(g);  
        drawSource(g);
   }


   public void drawBg(Graphics2D g) {
       g.setColor(new Color(100,0,255));
       g.fillRect(0,0,getWidth(),getHeight());
   }



    public void setPolygons(int n,int k) {
	V[0]=PolyVector.regular(n,k);
	int mode=2;
	try{
	 mode=M.C.ItC.getNormalize();
	}
	catch(Exception e) {}
	if(mode==2) V[0]=Reshape.reshape(V[0],2);
    }

    public void drawPolygons(Graphics2D g) {

	GeneralPath gp1=new GeneralPath();
	GeneralPath gp2=new GeneralPath();

	gp1=V[0].toGeneralPath();
	gp1=transform(gp1);
	g.setColor(new Color(50,0,100));
	g.fill(gp1);
	g.setColor(Color.white);
	g.draw(gp1);
	Complex z=new Complex();
	for(int i=0;i<4;++i) {
	   z=V[0].V[i].toComplex();
	   fillPoint(g,z,.04,Color.cyan,50);
	}
	z=V[0].V[VTX].toComplex();
	fillPoint(g,z,.04,new Color(255,255,0),50);
	doTest();
    }

    public void doTest() {
	double[] a0=XInvariants.invariant(V[0]);
	PolyVector V1=NewMap.map1(V[0]);
	double[] a1=XInvariants.invariant(V1);
	double b0=product(a0);
	double b1=product(a1);
	double b2=b1-b0;
	//System.out.println(b2);
    }


    public double product(double[] d) {
	double p=1;
	for(int i=0;i<d.length;++i) {
	    p=p*d[i];
	}
	p=Math.pow(p,1.0/d.length);
        return(p);
    }

    public void cycle() {
	V[0]=NewMap.cycle(1,V[0]);
        V[0]=Reshape.reshape(V[0],M.C.ItC.getNormalize());  
	M.I.V[0]=new PolyVector(V[0]); 
	M.I.V[0]=Reshape.reshape(M.I.V[0],M.C.ItC.getNormalize());  
    }
    public void setVertex() {
	setVertex0();
	M.I.V[0]=new PolyVector(V[0]); 
	M.I.V[0]=Reshape.reshape(M.I.V[0],M.C.ItC.getNormalize());  
    }

    public void setVertex0() {
	V[0].V[VTX]=new Vector(SOURCE);
    }

    public void findNearest() {
	int n=V[0].nearestVertex(SOURCE);
	VTX=n;
    }

    public void mouseClicked(MouseEvent e) {
      MouseData J=MouseData.process(e);
      int mode=J.mode;
	if(mode!=2) {
	   doScale(e,M);

	}
	if(mode==2) {
           doScale2(e,M);
	   findNearest();	
           setVertex();
	}
	repaint();
	M.C.repaint();
	M.I.repaint();
    }


    public void doMouseClick(int mode) {

	if((mode==1)||(mode==3)) {
	    doScale(mode,JX);
	}
	if(mode==2) {
	    doScale2(mode,JX);
	   findNearest();	
           setVertex();
	}
	if(mode==4) cycle();
	if(mode==10) stopTest();
	if(mode==11) specialTest(1);
	if(mode==6) printInvariants();
	repaint();
	M.C.repaint();
	M.I.repaint();
    }


    public boolean stopTest() {
	CT.HALT=true;
	TextCanvas.MESSAGE[0]="test stopped";
	M.T.repaint();
	return(true);
    }

    public boolean specialTest(int mode) {
	if(CT.HALT==false) return(false);
	CT=new ComputeTests(mode);
        new Thread(CT).start();	
        TextCanvas.MESSAGE[0]="test started";	
        M.T.repaint();
	return(true);
    }



    public void printInvariants() {
	double[] d=XInvariants.invariant(V[0]);
	System.out.println("invariants");
	for(int i=0;i<d.length;++i) System.out.println(d[i]);
    }


     public void mouseMoved(MouseEvent e) {	
          MouseData J=MouseData.process(e);
	  JX=new Point(J.X);
	  if(DRAG==true) {
            doScale2(2,JX);
	    findNearest();	
            setVertex();
	  }
	  repaint();
	  M.C.repaint();
	  M.I.repaint();
     }

    public void mousePressed(MouseEvent e) { }

     public void mouseReleased(MouseEvent e) {	 
     }

     public void mouseExited(MouseEvent e) {}   
     
     public void mouseEntered(MouseEvent e) {
	 requestFocus();
     } 

     public void mouseDragged(MouseEvent e) {
	MouseData J=MouseData.process(e);
	int mode=J.mode;

	if(mode==2) {
           doScale2(e,M);
	   findNearest();	
           setVertex();
	}
	repaint();
	M.C.repaint();	
        M.I.repaint();
     }

    public void keyPressed(KeyEvent e) {
	int test=-100;
	char ch=e.getKeyChar();
	if(ch=='z') test=1;   //zoom in
	if(ch=='x') {
            test=2; 
	    DRAG=true;
	}   
	if(ch=='c') test=3;   //zoom out
	if(ch=='v') test=4;   //cycle vertices
	if(ch=='1') test=11;   //hexagon range test
	if(ch=='0') test=10;   //stop test
	if(ch=='b') test=6;   //print invariants
        doMouseClick(test);
	repaint();
    }


    public void keyTyped(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {
	DRAG=false;
    }

}

