


public class DocumentProofMixed {

    public static void setup(Manager M,int n) {
	int[] a={1,0,0,0,1,1,1,1};
	DocumentProof.setDisplay(M,a);
	M.C.TC.FILL.val=1; 
	M.C.TC.setPiece(n,M);
	M.C.STRICT.val=0;
    }


    public static String go61(Manager M) {
	setup(M,23);
	int[] t={23,15,14,18};  
        M.P.setScales(0,650,35);
   	M.setPieces(t);
	String S="At this point in the proof, we know that J has measure 0 and that every point in J-JC is eventually mapped into JA.  Moreover, we know that JA is a Cantor lamination.  We also would like to understand the structure of J outside JA.  Our analysis stops short of giving complete information but we will do what we can.";

	S=S+"\n\nIn Pieces 14,15,18,23, the relevant map is nonsingular, which means that the local structure of J in the interior of these pieces is the same as that of JA.  In other words, J is a Cantor lamination in the interior of Pieces 14,15,18,23";
	return(S);
    }


    public static String go62(Manager M) {
	setup(M,25);
	int[] t={25,26,27,28,30}; 
   	M.setPieces(t);  
        M.P.setScales(0,650,35);
	String S="The same goes for pieces 25,26,27,28,30.";
	return(S);
    }

    public static String go63(Manager M) {
	setup(M,20);
	int[] t={20,21,24}; 
   	M.setPieces(t);  
        M.P.setScales(0,650,35);
	String S="We show that Pieces 20,21,24 have the following property. On each piece, the differential dF maps the vector (0,1) into the acute cone defined by the vectors (2,1) and (0,1). Call this Property A. ";

	S=S+"We have also shown that each strand of JA lies in the cone defined by (2,1) and (2,-1). Call this Property B.";

	S=S+"\n\nProperties A and B together imply that the vertical segments foliating the pieces considered in this step are all mapped transversely to JA.  But then each vertical segment intersects J in a Cantor set.  Hence J is still a Cantor lamination in Pieces 20,21,24."; 

	S=S+"\n\nPutting everything together, we can say that any point (x,y) in J having coordinates x>1 and y>1 and x \u2260 y has a Cantor lamination neighborhood in J.  When x=y (and still both coordinates are >1) there is a countable collection of isolated points in J.";
	return(S);
    }

    public static String go64(Manager M) {
	setup(M,16);
	int[] t={16,22,29}; 
   	M.setPieces(t);  
        M.P.setScales(350,350,100);
	String S="The rest of what we can show does not really lead to a crisp result. Moving back to the portion of the core containing the Cantor set JC, we show that dF is nonsingular in pieces 22 and 29, at least when F is suitable chosen:";

	S=S+"\n\nIn piece 22, we use the map (1,4,1).";

	S=S+"\n\nIn piece 29, we use the map (0,4,1).";

	S=S+"\n\nHowever these maps do not map us directly into the portion of the plane (x>1,y>1) already analyzed.  This means that we have to contend with potential blowups coming from the Gauss group.  The most we can say, without more analysis, is that J is a Cantor lamination in Pieces 22 and 29 outside of a finite union of algebraic curves.\n\n";

	S=S+"Piece 16 gives us more difficulties.  Each of the primary maps is singular on a finite union of algebraic curves in Piece 16.  So, we get the same weaker result as in Pieces 22 and 29.";

	return(S);
    }

    public static String go65(Manager M) {
	setup(M,0);
	int[] t={0,1,2,3,33,39}; 
   	M.setPieces(t);  
        M.P.setScales(350,350,100);

	String S="Let's put together some final result about the local structure of J-JC.";

	S=S+"\n\nLet S be the set of points in the union of Pieces 16,22,29 on which the structure of J is unknown. S is contained in a finite union of algebraic curves.  The points which get mapped into Pieces 16,22,29 come from pieces on which all the primary maps are nonsingular, namely the orange and magenta pieces in the portion of the core surrounding JC. For this reason, the only place where we don't know the structure of J-JC is a countable collection of algebraic curves.  This is still a 1-dimensional set.";

	S=S+"\n\nLooking at the picture of J, we think that J-JC is a Cantor lamination outside a countable union of points.  If we wanted to fight for this result, we would first pin down how the Gauss group interacts with the images of Pieces 22 and 29.  Then, we would partition Piece 16 into 3 kinds of pieces:";

	S=S+"\n\nPieces on which dF is nonsingular.";
	S=S+"\n\nPieces whose images under dF are provably disjoint from J.";
	S=S+"\n\nPieces which are foliated by segments mapped transversely to J.";
	S=S+"\n\nAt some point, we made such a partition, but it the transversality looked rather tedious to establish with an exact calculation.  In a sense, the verifications all boil down to the same as what we have already done, but the exact tests involved are a different, and they would further complicate the program.";

	return(S);
    }




}


