import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;
import java.awt.*;

/**This contains a variable which controls a global
   scaling switch.  When the switch is on, a global linear
   transformation is applied so that the Julia set has
   infinitesimal Euclidean 10-fold dihedral symmetry at the
   origin.*/

public class SpecialAffine {
    public static boolean GO=false;

    public static int getVal() {
      if(GO==true) return 1;
      return 0;
    }



    /**transforms a general path*/
    public static Path2D.Double map(Path2D.Double H) {
	Path2D.Double HH=new Path2D.Double(H);
	double u=scale();
	AffineTransform Z=new AffineTransform(.5,.5/u,.5,-.5/u,0,0);
	HH.transform(Z);
	return(HH);
    }

    /**untransforms a point*/
    public static Complex unMap(Complex z) {
       double tx=z.x;
       double ty=z.y;
       double u=scale();
       double ux=tx+u*ty;
       double uy=tx-u*ty;
       return(new Complex(ux,uy));
    }

    /**transforms a point*/
    public static Complex map(Complex z) {
       double tx=z.x;
       double ty=z.y;
       double u=scale();
       double ux=.5*tx+.5*ty;
       double uy=(.5/u)*tx+(-.5/u)*ty;
       return(new Complex(ux,uy));
    }

    /**same thing, in R2 coords.*/
    public static double[] map(double[] x) {
	Complex z=new Complex(x[0],x[1]);
	z=map(z);
	double[] X={z.x,z.y};
	return(X);
    }

    /**used in the special affine change*/
    public static double scale() {
       double a=QI.phi();
       double b=Math.tan(4*Math.PI/5);
       double u=-a*a/b;
       return(u);
    }
}

